﻿##################

def dessinerTableau(tab):
    """
    permet de dessiner le labyrinthe passe en parametre
    - les cases avec un 1 sont des murs => '#'
    - les cases avec un 0 sont des espaces vides => ' '
    """

    for j in range(0,len(tab[0])):
        for i in range(0,len(tab)):
            if (tab[i][j]==1):
                print('#', end=' ')
            else:
                print(' ', end=' ')
        print()

###################

def transpose(laby):
    """
    permet d'inverser lignes et colonnes d'un labyrinthe
    (utile pour la creation simple)
    """
    # nouveau laby
    laby2=[]
    for i in range(0,len(laby[0])):
        ligne=[]
        for j in range(0,len(laby)):
            ligne+=[0]
        laby2+=[ligne]

    # transposition
    for i in range(0,len(laby[0])):
        for j in range(0,len(laby)):
            laby2[i][j]=laby[j][i]

    return laby2


###################

def getLabyrinthe1():
    """
    construit et retourne un labyrinthe par defaut a parcourir
    (de taille 8x8)
    """

    # labyrinthe vide
    laby = []
    laby +=[[1,1,1,1,1,1,1,1]]
    laby +=[[1,0,0,1,0,0,0,1]]
    laby +=[[1,0,0,1,0,0,0,1]]
    laby +=[[1,0,1,1,1,1,0,1]]
    laby +=[[1,0,0,0,0,0,0,1]]
    laby +=[[1,0,1,1,0,1,0,1]]
    laby +=[[1,0,0,0,0,0,0,1]]
    laby +=[[1,1,1,1,1,1,1,1]]

    # nouveau laby
    return transpose(laby)

###################

def getLabyrinthe2():
    """
    construit et retourne un labyrinthe par defaut a parcourir
    (de taille 15x15)
    """
    laby = []
    laby +=[[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]]
    laby +=[[1,0,0,0,0,0,0,0,0,0,1,0,0,0,1]]
    laby +=[[1,0,1,1,1,1,1,0,1,0,1,0,1,1,1]]
    laby +=[[1,0,0,1,0,1,0,0,1,0,1,0,0,0,1]]
    laby +=[[1,0,0,0,0,0,0,0,1,0,0,0,1,0,1]]
    laby +=[[1,1,0,1,1,0,1,0,1,1,0,1,1,0,1]]
    laby +=[[1,0,0,0,0,0,1,0,0,0,0,1,0,0,1]]
    laby +=[[1,0,1,1,1,1,1,0,1,1,1,1,1,0,1]]
    laby +=[[1,0,1,0,0,1,0,0,0,0,0,0,1,0,1]]
    laby +=[[1,0,1,0,0,0,0,1,1,1,1,0,1,0,1]]
    laby +=[[1,0,1,0,0,1,0,1,0,0,0,0,1,0,1]]
    laby +=[[1,0,1,0,0,1,0,1,0,0,0,0,1,0,1]]
    laby +=[[1,0,1,1,0,1,1,1,1,1,1,1,1,0,1]]
    laby +=[[1,0,0,0,0,0,0,0,0,0,0,0,0,0,1]]
    laby +=[[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]]

    # nouveau laby
    return transpose(laby)

####################

def chercheChemin(laby,x,y):
    """
    cherche un chemin de base a partir de x,y
    A chaque iteration, parcourt tout le tableau
    """
    #print("####################################")
    #print("####################################")
    #print("########### parcours complet ######")
    #print("####################################")
    #print("####################################")

    # construit copie laby
    chemin=[]
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    # case en x et y est nulle
    chemin[x][y]=0
    indice=0

    #parcours le tableau tant qu'il y a des changements
    fin=False
    while not(fin) :
        # par defaut on s'arrete au prochain coup
        fin=True
        # on met a jour les cases
        for i in range(0,len(laby)):
            for j in range(0,len(laby[i])):
                # si la case est au bon indice
                if chemin[i][j]==indice:
                    # ajoute indice +1 cases voisines si pas un mur
                    changeindice(chemin,i+1,j,indice, laby)
                    changeindice(chemin,i-1,j,indice, laby)
                    changeindice(chemin,i,j+1,indice, laby)
                    changeindice(chemin,i,j-1,indice, laby)
                    # changement donc non fini
                    fin=False
        # on augmente l'indice de la case cherchee
        indice=indice+1

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

def changeindice(chemin,i,j,indice, laby):
    # si c'est un pas un mur
    if laby[i][j]!=1:
        # si la case est plus grande que indice+1
        if chemin[i][j]>indice+1:
            # on met la case a indice +1
            chemin[i][j]=indice+1

###################

def chercheCheminIntelligent(laby,x,y):
    """
	cherche un chemin de base a partir de x,y
	A chaque iteration, prend premier liste ouvert(pile)
	"""

    # construit copie laby
    chemin = []
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    #parcours le tableau tant qu'il y a des changements
    ouvert=[[x,y]]
    chemin[x][y]=0
    while len(ouvert) !=0 :
        # par defaut on s'arrete au prochain coup
        fin=True

        # on met a jour les cases dans ouvert
        case=ouvert[0]
        i=case[0]
        j=case[1]
        # print(i,",",j)
        # on supprime la case
        del ouvert[0]

        # prend indice de la case
        indice=chemin[i][j]

        # ajoute indice +1 cases voisines si pas un mur
        changeindiceInt(chemin,i+1,j,indice, laby,ouvert)
        changeindiceInt(chemin,i-1,j,indice, laby,ouvert)
        changeindiceInt(chemin,i,j+1,indice, laby,ouvert)
        changeindiceInt(chemin,i,j-1,indice, laby,ouvert)

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

def changeindiceInt(chemin,i,j,indice, laby,ouvert):
    # si c'est un pas un mur
    if laby[i][j]!=1:
        # si la case est plus grande que indice+1
        if chemin[i][j]>indice+1:
            # on met la case a indice +1
            chemin[i][j]=indice+1
            # on la stocke dans les cases a explorer
            ouvert+=[[i,j]]

###################

def chercheCheminDijkstra(laby,x,y,xfin,yfin):
    """
    cherche un chemin de base a partir de x,y
    A chaque iteration, prend plus petit (dijkstra)
    """

    # construit copie laby
    chemin=[]
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    #parcours le tableau tant qu'il y a des changements
    ouvert=[[x,y,0]]
    chemin[x][y]=0
    while len(ouvert) !=0 :
        # par defaut on s'arrete au prochain coup
        fin=True

        # on prend le plus petit dans ouvert
        min=1000
        ind=-1
        for num in range(0,len(ouvert)):
            # si c'est le min
            if ouvert[num][2]<min:
                min=ouvert[num][2]
                ind=num

        case=ouvert[ind]
        i=case[0]
        j=case[1]
        # on supprime la case
        del ouvert[ind]

        # si trouve sortie, on s'arrete
        if i==xfin and j==yfin:
            print ("fin")
            ouvert=[]

        else:
            # prend indice de la case
            indice=case[2]

            # ajoute indice +1 cases voisines si pas un mur
            changeindiceDijkstra(chemin,i+1,j,indice, laby,ouvert)
            changeindiceDijkstra(chemin,i-1,j,indice, laby,ouvert)
            changeindiceDijkstra(chemin,i,j+1,indice, laby,ouvert)
            changeindiceDijkstra(chemin,i,j-1,indice, laby,ouvert)

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

def changeindiceDijkstra(chemin,i,j,indice, laby,ouvert):
    # si c'est un pas un mur
    if laby[i][j]!=1:
        # si la case est plus grande que indice+1
        if chemin[i][j]>indice+1:
            # on met la case a indice +1
            chemin[i][j]=indice+1
            # on la stocke dans les cases a explorer
            ouvert+=[[i,j,indice+1]]

####################


def chercheCheminAStar(laby,x,y,xfin,yfin):
    """
    cherche un chemin de base a partir de x,y
    A chaque iteration, prend plus petit (dijkstra)
    """

    # construit copie laby
    chemin=[]
    for i in range(0,len(laby)):
        ligne=[]
        for j in range(0,len(laby[i])):
            ligne+=[1000]
        chemin+=[ligne]

    #parcours le tableau tant qu'il y a des changements
    distance_but=abs(x-xfin)+abs(y-yfin)
    ouvert=[[x,y,0,distance_but]]
    chemin[x][y]=0
    while len(ouvert) !=0 :
        # par defaut on s'arrete au prochain coup
        fin=True

        # on prend le plus petit dans ouvert
        min=1000
        ind=-1
        dmin=1000
        for num in range(0,len(ouvert)):
            # evalution
            f = ouvert[num][2]+ouvert[num][3]
            # si c'est le min
            if f<min:
                min=f
                ind=num
                dmin=ouvert[num][2]
            # en cas d'egalite, change si distnce reel plus grande
            if f==min:
                if ouvert[num][2]>dmin:
                    min=f
                    ind=num
                    dmin=ouvert[num][2]

        #print (ouvert)
        #print (ind,ouvert[ind])

        # si trouve sortie, on s'arrete
        if i==xfin and j==yfin:
            print ("fin")
            ouvert=[]

        #sinon on developpe
        else:
            case=ouvert[ind]
            i=case[0]
            j=case[1]
            # on supprime la case
            del ouvert[ind]

            # prend indice de la case
            indice=case[2]

            # ajoute indice +1 cases voisines si pas un mur
            changeindiceAStar(chemin,i+1,j,indice, laby,ouvert,xfin,yfin)
            changeindiceAStar(chemin,i-1,j,indice, laby,ouvert,xfin,yfin)
            changeindiceAStar(chemin,i,j+1,indice, laby,ouvert,xfin,yfin)
            changeindiceAStar(chemin,i,j-1,indice, laby,ouvert,xfin,yfin)

        # affiche le chemin
        #print("##############################")
        #dessinerChemin(chemin)
        #print("##############################")

    return chemin

def changeindiceAStar(chemin,i,j,indice, laby,ouvert,xfin,yfin):
    # si c'est un pas un mur
    if laby[i][j]!=1:
        # si la case est plus grande que indice+1
        if chemin[i][j]>indice+1:
            # on met la case a indice +1
            chemin[i][j]=indice+1
            # heurstique
            h=abs(i-xfin)+abs(j-yfin)
            # on la stocke dans les cases a explorer
            ouvert+=[[i,j,indice+1,h]]


####################

def dessinerChemin(tab):
    # dessine les lignes
    for j in range(0,len(tab)):

        # pour chaque colonnee
        for i in range(0,len(tab)):
            # recupere la valeur calculee
            val=tab[i][j]

            # si c'est 1000, c'est une case non visitee
            if val==1000:
                print("   ",end=' ')
            else:
                print(val,end=' ')
                if val<0:
                        val=-val*10
                if val==0:
                    val=1
                while (val<100):
                    val=val*10
                    print(' ',end='')
        print()


###################

def refaitchemin(tab,x,y):
    # on part de la fin et on remonte
    chemin=[[x,y]]
    indice=tab[x][y]
    fini=False

    #parcourt tant qu on pas revenu au depart
    while not fini:
        #print (x,y)

        #remonte d'un cran
        if tab[x-1][y] == indice-1 :
            x=x-1
        elif tab[x][y-1] == indice-1 :
            y=y-1
        elif tab[x+1][y] == indice-1 :
            x=x+1
        elif tab[x][y+1] == indice-1 :
            y=y+1

        #sauve
        chemin+=[[x,y]]

        #fin en 0
        indice=tab[x][y]
        if indice==0 :
            fini=True

    #retourne le chemin
    chemin.reverse()
    return chemin




###################

import time


laby=getLabyrinthe2()
dessinerTableau(laby)

xdep=5
ydep=5

# recherche normale

print ("Normal")
tmps1=time.clock()
chemin=chercheChemin(laby,xdep,ydep)
tmps2=time.clock()

dessinerChemin(chemin)
print (refaitchemin(chemin,6,10))
print (tmps2-tmps1)
print ("***")


# recherche parcours malin



print ("Malin")
tmps1=time.clock()
chemin=chercheCheminIntelligent(laby,xdep,ydep)
tmps2=time.clock()

dessinerChemin(chemin)
print (tmps2-tmps1)
print ("***")

# recherche dijkstra

print ("Dijkstra")
tmps1=time.clock()
chemin=chercheCheminDijkstra(laby,xdep,ydep,6,10)
tmps2=time.clock()

dessinerChemin(chemin)
print (tmps2-tmps1)
print ("***")


# recherche a*
print ("A star")

tmps1=time.clock()
chemin=chercheCheminAStar(laby,xdep,ydep,6,10)
tmps2=time.clock()

dessinerChemin(chemin)
print (refaitchemin(chemin,6,10))
print (tmps2-tmps1)
print ("***")
